name: "train_onfly"
random_seed: 0

stages {
	name: "src"
	type: SOURCE_LMDB
	source_param {
		path: "/media/data/voldemort/oranges/datasets/flaws/20161114/train"
		loop: true
		scale: 0.00390625
		classes_num: 3
	}
}

stages {
	name: "random_transform"
	type: RANDOM_TRANSFORM
	input: "src"
	random_transform_param {
		resize_min { fx: 0.9 }
		resize_max { fx: 1.1 }
		rotation_min: 0
		rotation_max: 360
		flip_x: true
		flip_y: true
		color_shift {
			basis: {
				shape_str: "3x3"
				d: -0.267963000000000 d: -0.513372000000000 d: -0.815258000000000
				d: -0.739006000000000 d: 0.652432000000000 d: -0.167939000000000
				d: -0.618115000000000 d: -0.557479000000000 d: 0.554212000000000

			}
			magnitude { d: 0.115241518218994 d: 0.000337062606812 d: 0.003960705261230 }
			stddev: 0.1
		}
	}
}

stages {
	name: "resize"
	type: AFFINE_TRANSFORM
	input: "random_transform"
	affine_transform_param {
	resize {
		fx: 0.81
		fy: 0.81
		}
	}
}

stages {
	name: "crop"
	type: FIXED_WINDOW
	input: "resize"

	fixed_window_param {
		rects {
			anchor: MIDDLE_CENTER
			rel_x: 0.5
			rel_y: 0.5
			width: 64
			height: 64
		}
	}
}
