name: "oranges_classflaw"
revision: 3
description: "model flaws_64x64_3c_2f_3o_20161114 (it. 122k): 0 negative, 1 stalks, 2 flaws"

stages {
  name: "item"
  type: SOURCE_CUSTOM
#  custom_param {
#    proxy: "test:ConcatCustomSource"
#    args: "oranges_segmentation.apl"
#  }
}

# Bounding-box resizing
stages {
  name: "item_normalized"
  type: RESIZE
  input: "item"
  resize_param {
    width: 280
    height: 280
  }
}

# CNN fully-convolutional
stages {
  name: "flaw_all"
  type: NEURAL_NETWORK
  input: "item_normalized"
  neural_network_param {
    deploy: "models/flaws_64x64_3c_2f_3o_20161114/deploy.prototxt"
    model: "models/flaws_64x64_3c_2f_3o_20161114/net_iter_122000.caffemodel"
    scale: 0.00390625

    fully_deploy: "models/flaws_64x64_3c_2f_3o_20161114/deploy_fully.prototxt"
    fully_subst_layers: "fc4 => fc4-conv, fc5 => fc5-conv, fc6 => fc6-conv"
    fully_cluster: true

    gpu: true
    encrypted: false
  }
}

# Exclude all the classes except the stalks
stages {
  name: "stalk_filter"
  type: CLASS_FILTER
  input: "flaw_all"
  class_filter_param {
    default_policy: CLASS_REJECT
    value_threshold: 0.95
    class_include: "1"
  }
}

# Stalk ranking
stages {
  name: "stalk_hidden"
  type: RANKING
  input: "stalk_filter"
  ranking_param {
    class_rank_def: "1:1"
    group_by_root: true
  }
}

# Make the stalk an output stage
stages {
  name: "stalk"
  type: JOIN
  input: "stalk_hidden"
}

# Caliper evaluation
stages {
  name: "caliper"
  type: CALIPER
  input: "item"
  input: "stalk_hidden"
  caliper_param {
    cross_major_axis: true
    #simmetry_ratio: 0.85
    #correction_policy: ZERO
  }
}


# Exclude all the classes except the flaws
stages {
  name: "flaw_candidate"
  type: RANKING
  input: "flaw_all"
  ranking_param {
    class_rank_def: "0:0, 1:0"
    group_by_root: true
  }
}

# Flaws filter based on values
stages {
  name: "flaw"
  type: CLASS_FILTER
  input: "flaw_candidate"
  class_filter_param {
    value_threshold: 0.95
  }
}
